<template>
	<div>
		<div class="minCenter">
			<el-tabs v-model="activeName" class="demo-tabs" @tab-click="handleClick">
				<el-tab-pane label="安全考核管理" name="1">
					<el-form :model="ruleForm" status-icon label-width="20px" class="topTitle">
						<el-row>
							<el-col :span="4">
								<el-form-item size="default">
									<el-tree-select v-model="ruleForm.searchParams.examineDepartmentId" :data="data" check-strictly="true" class="w100" :props="propse" placeholder="请选择" />
								</el-form-item>
							</el-col>
							<el-col :span="4">
								<el-form-item>
									<el-button size="default" type="primary" @click="listApi">查询</el-button>
									<el-button size="default" @click="resetForm">重置</el-button>
								</el-form-item>
							</el-col>
						</el-row>
					</el-form>
					<div class="btns">
						<div>
							<el-button size="default" type="primary" :icon="Plus" @click="openD('新建')">新建</el-button>
							<!-- <el-button size="default" :disabled="warning" type="warning" plain :icon="EditPen">修改</el-button> -->
							<el-button size="default" :disabled="danger" type="danger" plain :icon="Delete" @click="onDeleteAll">删除</el-button>
						</div>
					</div>
					<el-table ref="multipleTableRef" :data="tableData" style="width: 100%" @selection-change="handleSelectionChange">
						<el-table-column type="selection" align="center" width="55" />
						<el-table-column type="expand">
							<template #default="scope">
								<div class="tableC">
									<el-table :data="scope.row.currentExamineDtoList" style="width: 100%">
										<el-table-column align="center" prop="itemDetail" label="考核项目" />
										<el-table-column align="center" prop="content" label="考核内容" />
										<el-table-column align="center" prop="number" label="考核分数" />
									</el-table>
								</div>
							</template>
						</el-table-column>
						<el-table-column property="examineDate" align="center" :formatter="timeDate" label="考核日期" sortable />
						<el-table-column property="examineDepartmentName" align="center" label="考核部门" sortable />
						<el-table-column property="examinePersonName" label="考核人" align="center" sortable show-overflow-tooltip />
						<el-table-column property="beExaminedDepartmentName" label="被考核部门" align="center" sortable show-overflow-tooltip />
						<el-table-column property="examineTotalNumber" label="总分" align="center" sortable show-overflow-tooltip />
						<el-table-column property="numberDetailJson.number" label="考核结果" align="center" sortable show-overflow-tooltip />
						<el-table-column property="extraFile" label="附件" align="center" sortable show-overflow-tooltip />
						<el-table-column label="操作" align="center" width="250px">
							<template #default="scope">
								<el-button link type="primary" size="default" :icon="View" @click="openD('查看', scope.row.id)">查看</el-button>
								<el-button link type="primary" size="default" :icon="EditPen" @click="openD('修改', scope.row.id)">修改</el-button>
								<el-button link type="primary" size="default" :icon="Delete" @click="onDelete(scope.row.id)">删除</el-button>
							</template>
						</el-table-column>
					</el-table>
					<div class="pages">
						<el-pagination
							v-model:currentPage="currentPage4"
							v-model:page-size="pageSize4"
							:page-sizes="[10, 20, 30, 40]"
							layout="total, sizes, prev, pager, next, jumper"
							:total="total"
							@size-change="handleSizeChange"
							@current-change="handleCurrentChange"
						/>
					</div>
				</el-tab-pane>
				<el-tab-pane label="考核标准设定" name="2">
					<el-form :model="ruleForms" status-icon label-width="20px" class="topTitle">
						<el-row>
							<el-col :span="4">
								<el-form-item size="default">
									<el-input v-model="ruleForms.searchParams.title" placeholder="标准标题" />
								</el-form-item>
							</el-col>
							<el-col :span="4">
								<el-form-item>
									<el-button size="default" type="primary" @click="listApis">查询</el-button>
									<el-button size="default" @click="resetForms">重置</el-button>
								</el-form-item>
							</el-col>
						</el-row>
					</el-form>
					<div class="btns">
						<div>
							<el-button size="default" type="primary" :icon="Plus" @click="openDs('新建')">新建</el-button>
							<!-- <el-button size="default" :disabled="warnings" type="warning" plain :icon="EditPen">修改</el-button> -->
							<el-button size="default" :disabled="dangers" type="danger" plain :icon="Delete"  @click="onDeleteAlls">删除</el-button>
						</div>
					</div>
					<el-table ref="multipleTableRef" :data="tableDatas" style="width: 100%" @selection-change="handleSelectionChanges">
						<el-table-column type="selection" align="center" width="55" />
						<el-table-column type="expand">
							<template #default="scope">
								<div class="tableC">
									<el-table :data="scope.row.examineItemList" style="width: 100%">
										<el-table-column align="center" prop="itemType" label="类型" />
										<el-table-column align="center" prop="itemDetail" label="考核项目" />
										<el-table-column align="center" prop="content" label="考核内容" />
										<el-table-column align="center" prop="judgeStandard" label="评定标准" />
										<el-table-column align="center" prop="memo" label="考核说明" />
									</el-table>
								</div>
							</template>
						</el-table-column>
						<el-table-column label="标准标题" property="title" align="center" sortable />
						<el-table-column property="applyRange" align="center" label="适用范围" sortable />
						<el-table-column property="setPersonName" label="设定人" align="center" sortable show-overflow-tooltip />
						<el-table-column property="setPersonDepartmentName" label="设定人部门" align="center" sortable show-overflow-tooltip />
						<el-table-column property="setTimem" label="设定日期" align="center" :formatter="timeDate" sortable show-overflow-tooltip />
						<el-table-column property="templateCode" label="模板分类编码" align="center" sortable show-overflow-tooltip />
						<el-table-column property="acceptanceNumber" label="合格分数" align="center" sortable show-overflow-tooltip />
						<el-table-column label="操作" align="center" width="250px">
							<template #default="scope">
								<el-button link type="primary" size="default" :icon="View" @click="openDs('查看', scope.row.id)">查看</el-button>
								<el-button link type="primary" size="default" :icon="EditPen" @click="openDs('修改', scope.row.id)">修改</el-button>
								<el-button link type="primary" size="default" :icon="Delete" @click="onDeletes(scope.row.id)">删除</el-button>
							</template>
						</el-table-column>
					</el-table>
					<div class="pages">
						<el-pagination
							v-model:currentPage="currentPage4s"
							v-model:page-size="pageSize4s"
							:page-sizes="[10, 20, 30, 40]"
							layout="total, sizes, prev, pager, next, jumper"
							:total="totals"
							@size-change="handleSizeChanges"
							@current-change="handleCurrentChanges"
						/>
					</div>
				</el-tab-pane>
			</el-tabs>
		</div>
		<DailogAq ref="openAdd" @navAddorUpdata="onAddorUpdata"></DailogAq>
		<DailogKh ref="openAdds" @navAddorUpdata="onAddorUpdatas"></DailogKh>
	</div>
</template>
<script lang="ts">
import {timeDate} from '/@/assets/index.ts'
import DailogAq from './component/DailogAq.vue';
import DailogKh from './component/DailogKh.vue';
import { ref, toRefs, reactive, onMounted, defineComponent } from 'vue';
import { ElMessageBox, ElMessage, ElButton, ElInput, FormInstance } from 'element-plus';
import { Plus, Delete, Upload, Download, Refresh, View, EditPen } from '@element-plus/icons-vue';
import type { TabsPaneContext } from 'element-plus'
import { goalManagementApi } from '/@/api/goalManagement';
export default defineComponent({
	components: { ElButton, ElInput, DailogAq, DailogKh },
	setup() {
		// 搜索条件 安全考核管理
		const ruleForm = reactive({
			pageSize: 10,
			pageIndex: 1,
			searchParams: {
				examineDepartmentId: '',
			},
		});
		// 重置
		const resetForm = () => {
			ruleForm.searchParams.examineDepartmentId = '';
			listApi()
		};
		const listApi = () => {
			goalManagementApi()
				.getexamineMngList(ruleForm)
				.then((res) => {
					if (res.data.code == 200) {
						tableData.value = res.data.data;
						currentPage4.value = res.data.pageIndex;
						pageSize4.value = res.data.pageSize;
						total.value = res.data.total;
					} else {
						ElMessage.error(res.data.msg);
					}
				});
		};

		onMounted(() => {
			listApi();
		});
		const onAddorUpdata = () => {
			listApi();
		};
		// 表格
		const tableData = ref();
		const currentPage4 = ref();
		const pageSize4 = ref();
		const total = ref();
		const handleSizeChange = (val: number) => {
			// console.log(`${val} items per page`);
			ruleForm.pageSize = val;
			listApi();
		};
		const handleCurrentChange = (val: number) => {
			// console.log(`current page: ${val}`);
			ruleForm.pageIndex = val;
			listApi();
		};
		// 弹窗
		const openAdd = ref();
		const openD= (title: String, id: number) => {
			openAdd.value.openDailog(title, ruleForm.searchParams.examineDepartmentId, id);
		};
		// 删除
		const onDelete = (id: number) => {
			let arr=[]
			arr.push(id)
			ElMessageBox.confirm('确定删除所选项吗?', 'Warning', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					goalManagementApi()
						.getexamineMngDelete(arr)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									message: res.data.msg,
									type: 'success',
								});
								listApi();
							} else {
								ElMessage.error(res.data.msg);
							}
						});
				})
				.catch(() => {
					ElMessage({
						type: 'info',
						message: 'Delete canceled',
					});
				});
		};
		// 批量删除
		const warning = ref(true);
		const danger = ref(true);
		const deletAll = ref();
		const handleSelectionChange = (val: any) => {
			let valId = JSON.parse(JSON.stringify(val));
			let arr = [];
			for (let i = 0; i < valId.length; i++) {
				arr.push(valId[i].id);
			}
			deletAll.value = arr
			if (val.length == 1) {
				warning.value = false;
				danger.value = false;
			} else if (val.length == 0) {
				warning.value = true;
				danger.value = true;
			} else {
				warning.value = true;
				danger.value = false;
			}
		};
		const onDeleteAll = () => {
			ElMessageBox.confirm('确定删除所选项吗?', 'Warning', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					goalManagementApi()
						.getexamineMngDelete(deletAll.value)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									message: res.data.msg,
									type: 'success',
								});
								listApi();
							} else {
								ElMessage.error(res.data.msg);
							}
						});
				})
				.catch(() => {
					// ElMessage({
					// 	type: 'info',
					// 	message: 'Delete canceled',
					// });
				});
		};
		// 切换
		const activeName = ref('1');
		const handleClick = (val: TabsPaneContext) => {
			console.log(val)
			if (val.props.name == '1') {
				listApi();
			}else{
				listApis();
			}
		};
		// 搜索条件 考核标准设定
		const ruleForms = reactive({
			pageSize: 10,
			pageIndex: 1,
			searchParams: {
				title: '', //标准标题
			},
		});
		// 重置
		const resetForms = () => {
			ruleForms.searchParams.title = '';
			listApis()
		};
		const listApis = () => {
			goalManagementApi()
				.getexamineTemplateList(ruleForms)
				.then((res) => {
					if (res.data.code == 200) {
						tableDatas.value = res.data.data;
						currentPage4s.value = res.data.pageIndex;
						pageSize4s.value = res.data.pageSize;
						totals.value = res.data.total;
					} else {
						ElMessage.error(res.data.msg);
					}
				});
		};
		onMounted(() => {
			listApis();
			department()
		});
		const onAddorUpdatas = () => {
			listApis();
		};
		// 表格
		const tableDatas = ref();
		const currentPage4s = ref();
		const pageSize4s = ref();
		const totals = ref();
		const handleSizeChanges = (val: number) => {
			// console.log(`${val} items per page`);
			ruleForms.pageSize = val;
			listApis();
		};
		const handleCurrentChanges = (val: number) => {
			// console.log(`current page: ${val}`);
			ruleForms.pageIndex = val;
			listApis();
		};
		// 弹窗
		const openAdds = ref();
		const openDs = (title: String, id: number) => {
			openAdds.value.openDailog(title, ruleForm.searchParams.examineDepartmentId, id);
		};
		// 删除
		const onDeletes = (id: number) => {
			let arr=[]
			arr.push(id)
			ElMessageBox.confirm('确定删除所选项吗?', 'Warning', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					goalManagementApi()
						.getexamineTemplateDelete(arr)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									message: res.data.msg,
									type: 'success',
								});
								listApis();
							} else {
								ElMessage.error(res.data.msg);
							}
						});
				})
				.catch(() => {
					ElMessage({
						type: 'info',
						message: 'Delete canceled',
					});
				});
		};
		// 批量删除
		const warnings = ref(true);
		const dangers = ref(true);
		const deletAlls = ref();
		const handleSelectionChanges = (val: any) => {
			let valId = JSON.parse(JSON.stringify(val));
			let arr = [];
			for (let i = 0; i < valId.length; i++) {
				arr.push(valId[i].id);
			}
			deletAlls.value = arr;
			if (val.length == 1) {
				warnings.value = false;
				dangers.value = false;
			} else if (val.length == 0) {
				warnings.value = true;
				dangers.value = true;
			} else {
				warnings.value = true;
				dangers.value = false;
			}
		};
		const onDeleteAlls = () => {
			ElMessageBox.confirm('确定删除所选项吗?', 'Warning', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning',
			})
				.then(() => {
					goalManagementApi()
						.getexamineTemplateDelete(deletAll.value)
						.then((res) => {
							if (res.data.code == 200) {
								ElMessage({
									message: res.data.msg,
									type: 'success',
								});
								listApis();
							} else {
								ElMessage.error(res.data.msg);
							}
						});
				})
				.catch(() => {
					// ElMessage({
					// 	type: 'info',
					// 	message: 'Delete canceled',
					// });
				});
		};
			//部门树
		const department = () => {
			goalManagementApi()
				.getTreedepartment()
				.then((res) => {
					if (res.data.code == 200) {
						data.value = res.data.data;
					} else {
						ElMessage.error(res.data.msg);
					}
				});
		};
		const propse = {
			label: 'depName',
			children: 'children',
			value: 'depId',
		};
		const data = ref();
		return {
			timeDate,
			department,
			propse,
			data,
			activeName,
			ruleForm,
			resetForm,
			listApi,
			handleClick,
			onAddorUpdata,
			tableData,
			currentPage4,
			pageSize4,
			total,
			handleSizeChange,
			handleCurrentChange,
			openAdd,
			openD,
			onDelete,
			warning,
			danger,
			deletAll,
			handleSelectionChange,
			onDeleteAll,
			ruleForms,
			resetForms,
			listApis,
			onAddorUpdatas,
			tableDatas,
			currentPage4s,
			pageSize4s,
			totals,
			handleSizeChanges,
			handleCurrentChanges,
			openAdds,
			openDs,
			onDeletes,
			warnings,
			dangers,
			deletAlls,
			handleSelectionChanges,
			onDeleteAlls,
			Plus,
			Delete,
			Upload,
			Download,
			Refresh,
			View,
			EditPen,
		};
	},
});
</script>
<style scoped>
.minCenter {
	width: 100%;
	background-color: #fff;
	margin-top: 10px;
	padding: 0 20px;
}
.btns {
	padding: 20px;
}
.topTitle {
	padding: 5px 0 20px 0;
	border-bottom: 1px solid #dedede;
}
.pages {
	padding: 20px 0;
	display: flex;
	justify-content: right;
}
.tableC {
	margin: 0 10%;
}
</style>
